#pragma config(Sensor, S1,     color,          sensorEV3_Color, modeEV3Color_Color)
#pragma config(Sensor, S2,     rightSonar,     sensorEV3_Ultrasonic)
#pragma config(Sensor, S3,     gyro,           sensorEV3_Gyro)
#pragma config(Sensor, S4,     frontSonar,     sensorEV3_Ultrasonic)
#pragma config(Motor,  motorB,          leftMotor,     tmotorEV3_Large, openLoop, encoder)
#pragma config(Motor,  motorC,          rightMotor,    tmotorEV3_Large, openLoop, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

const int v=100, ang=87, distR=6, distF=5, encMove=1050, kletka=30, encCalibr=200, kF=15;
const float kTurn=2, kPEnc=5, kPR=5;
float u=0, e;
int pochta[100], n=0;
bool end=true;
#define nameOfFile "path.dat"

void forwardCalibr()
{
	nMotorEncoder[leftMotor]=nMotorEncoder[rightMotor]=0;
	motor[leftMotor]=motor[rightMotor]=v;
	while(abs(nMotorEncoder[leftMotor])< abs(encCalibr))
		sleep(1);

	motor[leftMotor]=motor[rightMotor]=0;
	sleep(50);

	while(SensorValue[frontSonar]!=distF)
	{
		e=(SensorValue[frontSonar]-distF)*kF;
		motor[leftMotor]=motor[rightMotor]=e;
		sleep(10);
	}
}

void fileWrite()
{
	int h=fileOpenWrite(nameOfFile);
	fileWriteFloat(h, n);
	for(int m=0; m<=n; m++)
		fileWriteFloat(h, pochta[m]);

	fileClose(h);
}

void turn(int angTurn)
{
	resetGyro(gyro);
	sleep(100);

	while(abs(SensorValue[gyro])<abs(angTurn))
	{
		motor[leftMotor]=v*sgn(angTurn)/kTurn;
		motor[rightMotor]=-v*sgn(angTurn)/kTurn;
		sleep(1);
	}
	motor[leftMotor]=motor[rightMotor]=0;
	if (angTurn>0)
	{
		displayCenteredBigTextLine(1, "Right");
		if(end)
			pochta[n++]=1;
	}
	else
	{
		displayCenteredBigTextLine(1, "Left");
		if(end)
			pochta[n++]=2;
		if(SensorValue[frontSonar]<kletka-10)
			forwardCalibr();
	}
}

void moveRobot()
{
	nMotorEncoder[leftMotor]=nMotorEncoder[rightMotor]=0;
	while(abs(nMotorEncoder[leftMotor])<encMove)
	{
		if (SensorValue[rightSonar]<distR*2)
			u=(SensorValue[rightSonar]-distR)*kPR;
		else
			u=(nMotorEncoder[rightMotor]-nMotorEncoder[leftMotor])*kPEnc;
		motor[leftMotor]=v+u;
		motor[rightMotor]=v-u;
		sleep(1);
	}

	displayCenteredBigTextLine(1, "Front");
	motor[leftMotor]=motor[rightMotor]=0;
	if(end)
		pochta[n++]=3;

	if(SensorValue[frontSonar]<kletka-10)
		forwardCalibr();
	if(SensorValue[color]==5 )
	{
		end=false;
		playSound(soundBeepBeep);
		sleep(100);
	}
}

void centerMaze()
{
	while(end)
	{
		if (SensorValue[rightSonar]>kletka)
		{
			turn(ang);
			moveRobot();
		}
		else if (SensorValue[frontSonar]>kletka)
			moveRobot();
		else
			turn(-ang);
	}
}

void cutElem(int i)
{
	if(i<n)
	{
		for (int j=i; j<n; j++)
			pochta[j]=pochta[j+1];
	}
	n--;
}

void cutMas()
{
	int i=0;
	while(i<n)
	{
		if(pochta[i]==2 && pochta[i+1]==2)
		{
			cutElem(i);
			cutElem(i);
			while((pochta[i] + pochta[i-1])%3==0)
			{
				cutElem(i-1);
				cutElem(i-1);
				i--;
			}
			if(pochta[i] == pochta[i-1])
			{
				cutElem(i-1);
				cutElem(i-1);
				i--;
			}
			else
			{
				if(pochta[i]>pochta[i-1])
					pochta[i-1]=3-pochta[i-1];
				else
					pochta[i]=3-pochta[i];
			}
		}
		i++;
	}
}

task main()
{
	resetGyro(gyro);
	sleep(1000);

	centerMaze();
	cutMas();
	fileWrite();
}
